//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private GaplessADX[] cacheGaplessADX = null;
        private GaplessATR[] cacheGaplessATR = null;
        private GaplessBands[] cacheGaplessBands = null;
        private GaplessCCI[] cacheGaplessCCI = null;
        private GaplessDI[] cacheGaplessDI = null;
        private GaplessEMA[] cacheGaplessEMA = null;
        private GaplessHMA[] cacheGaplessHMA = null;
        private GaplessLinearRegression[] cacheGaplessLinearRegression = null;
        private GaplessMACD[] cacheGaplessMACD = null;
        private GaplessParabolicSAR[] cacheGaplessParabolicSAR = null;
        private GaplessRSI[] cacheGaplessRSI = null;
        private GaplessSMA[] cacheGaplessSMA = null;
        private GaplessStochastics[] cacheGaplessStochastics = null;
        private GaplessSupportResistance[] cacheGaplessSupportResistance = null;
        private GaplessWMA[] cacheGaplessWMA = null;

        private static GaplessADX checkGaplessADX = new GaplessADX();
        private static GaplessATR checkGaplessATR = new GaplessATR();
        private static GaplessBands checkGaplessBands = new GaplessBands();
        private static GaplessCCI checkGaplessCCI = new GaplessCCI();
        private static GaplessDI checkGaplessDI = new GaplessDI();
        private static GaplessEMA checkGaplessEMA = new GaplessEMA();
        private static GaplessHMA checkGaplessHMA = new GaplessHMA();
        private static GaplessLinearRegression checkGaplessLinearRegression = new GaplessLinearRegression();
        private static GaplessMACD checkGaplessMACD = new GaplessMACD();
        private static GaplessParabolicSAR checkGaplessParabolicSAR = new GaplessParabolicSAR();
        private static GaplessRSI checkGaplessRSI = new GaplessRSI();
        private static GaplessSMA checkGaplessSMA = new GaplessSMA();
        private static GaplessStochastics checkGaplessStochastics = new GaplessStochastics();
        private static GaplessSupportResistance checkGaplessSupportResistance = new GaplessSupportResistance();
        private static GaplessWMA checkGaplessWMA = new GaplessWMA();

        /// <summary>
        /// GaplessADX
        /// </summary>
        /// <returns></returns>
        public GaplessADX GaplessADX(int period)
        {
            return GaplessADX(Input, period);
        }

        /// <summary>
        /// GaplessADX
        /// </summary>
        /// <returns></returns>
        public GaplessADX GaplessADX(Data.IDataSeries input, int period)
        {
            if (cacheGaplessADX != null)
                for (int idx = 0; idx < cacheGaplessADX.Length; idx++)
                    if (cacheGaplessADX[idx].Period == period && cacheGaplessADX[idx].EqualsInput(input))
                        return cacheGaplessADX[idx];

            lock (checkGaplessADX)
            {
                checkGaplessADX.Period = period;
                period = checkGaplessADX.Period;

                if (cacheGaplessADX != null)
                    for (int idx = 0; idx < cacheGaplessADX.Length; idx++)
                        if (cacheGaplessADX[idx].Period == period && cacheGaplessADX[idx].EqualsInput(input))
                            return cacheGaplessADX[idx];

                GaplessADX indicator = new GaplessADX();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessADX[] tmp = new GaplessADX[cacheGaplessADX == null ? 1 : cacheGaplessADX.Length + 1];
                if (cacheGaplessADX != null)
                    cacheGaplessADX.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessADX = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessATR
        /// </summary>
        /// <returns></returns>
        public GaplessATR GaplessATR(int period)
        {
            return GaplessATR(Input, period);
        }

        /// <summary>
        /// GaplessATR
        /// </summary>
        /// <returns></returns>
        public GaplessATR GaplessATR(Data.IDataSeries input, int period)
        {
            if (cacheGaplessATR != null)
                for (int idx = 0; idx < cacheGaplessATR.Length; idx++)
                    if (cacheGaplessATR[idx].Period == period && cacheGaplessATR[idx].EqualsInput(input))
                        return cacheGaplessATR[idx];

            lock (checkGaplessATR)
            {
                checkGaplessATR.Period = period;
                period = checkGaplessATR.Period;

                if (cacheGaplessATR != null)
                    for (int idx = 0; idx < cacheGaplessATR.Length; idx++)
                        if (cacheGaplessATR[idx].Period == period && cacheGaplessATR[idx].EqualsInput(input))
                            return cacheGaplessATR[idx];

                GaplessATR indicator = new GaplessATR();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessATR[] tmp = new GaplessATR[cacheGaplessATR == null ? 1 : cacheGaplessATR.Length + 1];
                if (cacheGaplessATR != null)
                    cacheGaplessATR.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessATR = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessBands
        /// </summary>
        /// <returns></returns>
        public GaplessBands GaplessBands(double numStdDev, int period)
        {
            return GaplessBands(Input, numStdDev, period);
        }

        /// <summary>
        /// GaplessBands
        /// </summary>
        /// <returns></returns>
        public GaplessBands GaplessBands(Data.IDataSeries input, double numStdDev, int period)
        {
            if (cacheGaplessBands != null)
                for (int idx = 0; idx < cacheGaplessBands.Length; idx++)
                    if (Math.Abs(cacheGaplessBands[idx].NumStdDev - numStdDev) <= double.Epsilon && cacheGaplessBands[idx].Period == period && cacheGaplessBands[idx].EqualsInput(input))
                        return cacheGaplessBands[idx];

            lock (checkGaplessBands)
            {
                checkGaplessBands.NumStdDev = numStdDev;
                numStdDev = checkGaplessBands.NumStdDev;
                checkGaplessBands.Period = period;
                period = checkGaplessBands.Period;

                if (cacheGaplessBands != null)
                    for (int idx = 0; idx < cacheGaplessBands.Length; idx++)
                        if (Math.Abs(cacheGaplessBands[idx].NumStdDev - numStdDev) <= double.Epsilon && cacheGaplessBands[idx].Period == period && cacheGaplessBands[idx].EqualsInput(input))
                            return cacheGaplessBands[idx];

                GaplessBands indicator = new GaplessBands();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.NumStdDev = numStdDev;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessBands[] tmp = new GaplessBands[cacheGaplessBands == null ? 1 : cacheGaplessBands.Length + 1];
                if (cacheGaplessBands != null)
                    cacheGaplessBands.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessBands = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessCCI
        /// </summary>
        /// <returns></returns>
        public GaplessCCI GaplessCCI(int period)
        {
            return GaplessCCI(Input, period);
        }

        /// <summary>
        /// GaplessCCI
        /// </summary>
        /// <returns></returns>
        public GaplessCCI GaplessCCI(Data.IDataSeries input, int period)
        {
            if (cacheGaplessCCI != null)
                for (int idx = 0; idx < cacheGaplessCCI.Length; idx++)
                    if (cacheGaplessCCI[idx].Period == period && cacheGaplessCCI[idx].EqualsInput(input))
                        return cacheGaplessCCI[idx];

            lock (checkGaplessCCI)
            {
                checkGaplessCCI.Period = period;
                period = checkGaplessCCI.Period;

                if (cacheGaplessCCI != null)
                    for (int idx = 0; idx < cacheGaplessCCI.Length; idx++)
                        if (cacheGaplessCCI[idx].Period == period && cacheGaplessCCI[idx].EqualsInput(input))
                            return cacheGaplessCCI[idx];

                GaplessCCI indicator = new GaplessCCI();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessCCI[] tmp = new GaplessCCI[cacheGaplessCCI == null ? 1 : cacheGaplessCCI.Length + 1];
                if (cacheGaplessCCI != null)
                    cacheGaplessCCI.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessCCI = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessDI
        /// </summary>
        /// <returns></returns>
        public GaplessDI GaplessDI(int period)
        {
            return GaplessDI(Input, period);
        }

        /// <summary>
        /// GaplessDI
        /// </summary>
        /// <returns></returns>
        public GaplessDI GaplessDI(Data.IDataSeries input, int period)
        {
            if (cacheGaplessDI != null)
                for (int idx = 0; idx < cacheGaplessDI.Length; idx++)
                    if (cacheGaplessDI[idx].Period == period && cacheGaplessDI[idx].EqualsInput(input))
                        return cacheGaplessDI[idx];

            lock (checkGaplessDI)
            {
                checkGaplessDI.Period = period;
                period = checkGaplessDI.Period;

                if (cacheGaplessDI != null)
                    for (int idx = 0; idx < cacheGaplessDI.Length; idx++)
                        if (cacheGaplessDI[idx].Period == period && cacheGaplessDI[idx].EqualsInput(input))
                            return cacheGaplessDI[idx];

                GaplessDI indicator = new GaplessDI();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessDI[] tmp = new GaplessDI[cacheGaplessDI == null ? 1 : cacheGaplessDI.Length + 1];
                if (cacheGaplessDI != null)
                    cacheGaplessDI.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessDI = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessEMA
        /// </summary>
        /// <returns></returns>
        public GaplessEMA GaplessEMA(int period)
        {
            return GaplessEMA(Input, period);
        }

        /// <summary>
        /// GaplessEMA
        /// </summary>
        /// <returns></returns>
        public GaplessEMA GaplessEMA(Data.IDataSeries input, int period)
        {
            if (cacheGaplessEMA != null)
                for (int idx = 0; idx < cacheGaplessEMA.Length; idx++)
                    if (cacheGaplessEMA[idx].Period == period && cacheGaplessEMA[idx].EqualsInput(input))
                        return cacheGaplessEMA[idx];

            lock (checkGaplessEMA)
            {
                checkGaplessEMA.Period = period;
                period = checkGaplessEMA.Period;

                if (cacheGaplessEMA != null)
                    for (int idx = 0; idx < cacheGaplessEMA.Length; idx++)
                        if (cacheGaplessEMA[idx].Period == period && cacheGaplessEMA[idx].EqualsInput(input))
                            return cacheGaplessEMA[idx];

                GaplessEMA indicator = new GaplessEMA();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessEMA[] tmp = new GaplessEMA[cacheGaplessEMA == null ? 1 : cacheGaplessEMA.Length + 1];
                if (cacheGaplessEMA != null)
                    cacheGaplessEMA.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessEMA = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessHMA
        /// </summary>
        /// <returns></returns>
        public GaplessHMA GaplessHMA(int period)
        {
            return GaplessHMA(Input, period);
        }

        /// <summary>
        /// GaplessHMA
        /// </summary>
        /// <returns></returns>
        public GaplessHMA GaplessHMA(Data.IDataSeries input, int period)
        {
            if (cacheGaplessHMA != null)
                for (int idx = 0; idx < cacheGaplessHMA.Length; idx++)
                    if (cacheGaplessHMA[idx].Period == period && cacheGaplessHMA[idx].EqualsInput(input))
                        return cacheGaplessHMA[idx];

            lock (checkGaplessHMA)
            {
                checkGaplessHMA.Period = period;
                period = checkGaplessHMA.Period;

                if (cacheGaplessHMA != null)
                    for (int idx = 0; idx < cacheGaplessHMA.Length; idx++)
                        if (cacheGaplessHMA[idx].Period == period && cacheGaplessHMA[idx].EqualsInput(input))
                            return cacheGaplessHMA[idx];

                GaplessHMA indicator = new GaplessHMA();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessHMA[] tmp = new GaplessHMA[cacheGaplessHMA == null ? 1 : cacheGaplessHMA.Length + 1];
                if (cacheGaplessHMA != null)
                    cacheGaplessHMA.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessHMA = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessLinearRegression
        /// </summary>
        /// <returns></returns>
        public GaplessLinearRegression GaplessLinearRegression(int period)
        {
            return GaplessLinearRegression(Input, period);
        }

        /// <summary>
        /// GaplessLinearRegression
        /// </summary>
        /// <returns></returns>
        public GaplessLinearRegression GaplessLinearRegression(Data.IDataSeries input, int period)
        {
            if (cacheGaplessLinearRegression != null)
                for (int idx = 0; idx < cacheGaplessLinearRegression.Length; idx++)
                    if (cacheGaplessLinearRegression[idx].Period == period && cacheGaplessLinearRegression[idx].EqualsInput(input))
                        return cacheGaplessLinearRegression[idx];

            lock (checkGaplessLinearRegression)
            {
                checkGaplessLinearRegression.Period = period;
                period = checkGaplessLinearRegression.Period;

                if (cacheGaplessLinearRegression != null)
                    for (int idx = 0; idx < cacheGaplessLinearRegression.Length; idx++)
                        if (cacheGaplessLinearRegression[idx].Period == period && cacheGaplessLinearRegression[idx].EqualsInput(input))
                            return cacheGaplessLinearRegression[idx];

                GaplessLinearRegression indicator = new GaplessLinearRegression();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessLinearRegression[] tmp = new GaplessLinearRegression[cacheGaplessLinearRegression == null ? 1 : cacheGaplessLinearRegression.Length + 1];
                if (cacheGaplessLinearRegression != null)
                    cacheGaplessLinearRegression.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessLinearRegression = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessMACD
        /// </summary>
        /// <returns></returns>
        public GaplessMACD GaplessMACD(int fast, int slow, int smooth)
        {
            return GaplessMACD(Input, fast, slow, smooth);
        }

        /// <summary>
        /// GaplessMACD
        /// </summary>
        /// <returns></returns>
        public GaplessMACD GaplessMACD(Data.IDataSeries input, int fast, int slow, int smooth)
        {
            if (cacheGaplessMACD != null)
                for (int idx = 0; idx < cacheGaplessMACD.Length; idx++)
                    if (cacheGaplessMACD[idx].Fast == fast && cacheGaplessMACD[idx].Slow == slow && cacheGaplessMACD[idx].Smooth == smooth && cacheGaplessMACD[idx].EqualsInput(input))
                        return cacheGaplessMACD[idx];

            lock (checkGaplessMACD)
            {
                checkGaplessMACD.Fast = fast;
                fast = checkGaplessMACD.Fast;
                checkGaplessMACD.Slow = slow;
                slow = checkGaplessMACD.Slow;
                checkGaplessMACD.Smooth = smooth;
                smooth = checkGaplessMACD.Smooth;

                if (cacheGaplessMACD != null)
                    for (int idx = 0; idx < cacheGaplessMACD.Length; idx++)
                        if (cacheGaplessMACD[idx].Fast == fast && cacheGaplessMACD[idx].Slow == slow && cacheGaplessMACD[idx].Smooth == smooth && cacheGaplessMACD[idx].EqualsInput(input))
                            return cacheGaplessMACD[idx];

                GaplessMACD indicator = new GaplessMACD();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Fast = fast;
                indicator.Slow = slow;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessMACD[] tmp = new GaplessMACD[cacheGaplessMACD == null ? 1 : cacheGaplessMACD.Length + 1];
                if (cacheGaplessMACD != null)
                    cacheGaplessMACD.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessMACD = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessParabolicSAR
        /// </summary>
        /// <returns></returns>
        public GaplessParabolicSAR GaplessParabolicSAR(double acceleration, double accelerationMax, double accelerationStep)
        {
            return GaplessParabolicSAR(Input, acceleration, accelerationMax, accelerationStep);
        }

        /// <summary>
        /// GaplessParabolicSAR
        /// </summary>
        /// <returns></returns>
        public GaplessParabolicSAR GaplessParabolicSAR(Data.IDataSeries input, double acceleration, double accelerationMax, double accelerationStep)
        {
            if (cacheGaplessParabolicSAR != null)
                for (int idx = 0; idx < cacheGaplessParabolicSAR.Length; idx++)
                    if (Math.Abs(cacheGaplessParabolicSAR[idx].Acceleration - acceleration) <= double.Epsilon && Math.Abs(cacheGaplessParabolicSAR[idx].AccelerationMax - accelerationMax) <= double.Epsilon && Math.Abs(cacheGaplessParabolicSAR[idx].AccelerationStep - accelerationStep) <= double.Epsilon && cacheGaplessParabolicSAR[idx].EqualsInput(input))
                        return cacheGaplessParabolicSAR[idx];

            lock (checkGaplessParabolicSAR)
            {
                checkGaplessParabolicSAR.Acceleration = acceleration;
                acceleration = checkGaplessParabolicSAR.Acceleration;
                checkGaplessParabolicSAR.AccelerationMax = accelerationMax;
                accelerationMax = checkGaplessParabolicSAR.AccelerationMax;
                checkGaplessParabolicSAR.AccelerationStep = accelerationStep;
                accelerationStep = checkGaplessParabolicSAR.AccelerationStep;

                if (cacheGaplessParabolicSAR != null)
                    for (int idx = 0; idx < cacheGaplessParabolicSAR.Length; idx++)
                        if (Math.Abs(cacheGaplessParabolicSAR[idx].Acceleration - acceleration) <= double.Epsilon && Math.Abs(cacheGaplessParabolicSAR[idx].AccelerationMax - accelerationMax) <= double.Epsilon && Math.Abs(cacheGaplessParabolicSAR[idx].AccelerationStep - accelerationStep) <= double.Epsilon && cacheGaplessParabolicSAR[idx].EqualsInput(input))
                            return cacheGaplessParabolicSAR[idx];

                GaplessParabolicSAR indicator = new GaplessParabolicSAR();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Acceleration = acceleration;
                indicator.AccelerationMax = accelerationMax;
                indicator.AccelerationStep = accelerationStep;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessParabolicSAR[] tmp = new GaplessParabolicSAR[cacheGaplessParabolicSAR == null ? 1 : cacheGaplessParabolicSAR.Length + 1];
                if (cacheGaplessParabolicSAR != null)
                    cacheGaplessParabolicSAR.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessParabolicSAR = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessRSI
        /// </summary>
        /// <returns></returns>
        public GaplessRSI GaplessRSI(int period, int smooth)
        {
            return GaplessRSI(Input, period, smooth);
        }

        /// <summary>
        /// GaplessRSI
        /// </summary>
        /// <returns></returns>
        public GaplessRSI GaplessRSI(Data.IDataSeries input, int period, int smooth)
        {
            if (cacheGaplessRSI != null)
                for (int idx = 0; idx < cacheGaplessRSI.Length; idx++)
                    if (cacheGaplessRSI[idx].Period == period && cacheGaplessRSI[idx].Smooth == smooth && cacheGaplessRSI[idx].EqualsInput(input))
                        return cacheGaplessRSI[idx];

            lock (checkGaplessRSI)
            {
                checkGaplessRSI.Period = period;
                period = checkGaplessRSI.Period;
                checkGaplessRSI.Smooth = smooth;
                smooth = checkGaplessRSI.Smooth;

                if (cacheGaplessRSI != null)
                    for (int idx = 0; idx < cacheGaplessRSI.Length; idx++)
                        if (cacheGaplessRSI[idx].Period == period && cacheGaplessRSI[idx].Smooth == smooth && cacheGaplessRSI[idx].EqualsInput(input))
                            return cacheGaplessRSI[idx];

                GaplessRSI indicator = new GaplessRSI();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessRSI[] tmp = new GaplessRSI[cacheGaplessRSI == null ? 1 : cacheGaplessRSI.Length + 1];
                if (cacheGaplessRSI != null)
                    cacheGaplessRSI.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessRSI = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessSMA
        /// </summary>
        /// <returns></returns>
        public GaplessSMA GaplessSMA(int period)
        {
            return GaplessSMA(Input, period);
        }

        /// <summary>
        /// GaplessSMA
        /// </summary>
        /// <returns></returns>
        public GaplessSMA GaplessSMA(Data.IDataSeries input, int period)
        {
            if (cacheGaplessSMA != null)
                for (int idx = 0; idx < cacheGaplessSMA.Length; idx++)
                    if (cacheGaplessSMA[idx].Period == period && cacheGaplessSMA[idx].EqualsInput(input))
                        return cacheGaplessSMA[idx];

            lock (checkGaplessSMA)
            {
                checkGaplessSMA.Period = period;
                period = checkGaplessSMA.Period;

                if (cacheGaplessSMA != null)
                    for (int idx = 0; idx < cacheGaplessSMA.Length; idx++)
                        if (cacheGaplessSMA[idx].Period == period && cacheGaplessSMA[idx].EqualsInput(input))
                            return cacheGaplessSMA[idx];

                GaplessSMA indicator = new GaplessSMA();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessSMA[] tmp = new GaplessSMA[cacheGaplessSMA == null ? 1 : cacheGaplessSMA.Length + 1];
                if (cacheGaplessSMA != null)
                    cacheGaplessSMA.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessSMA = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessStochastics
        /// </summary>
        /// <returns></returns>
        public GaplessStochastics GaplessStochastics(int periodD, int periodK, int smooth)
        {
            return GaplessStochastics(Input, periodD, periodK, smooth);
        }

        /// <summary>
        /// GaplessStochastics
        /// </summary>
        /// <returns></returns>
        public GaplessStochastics GaplessStochastics(Data.IDataSeries input, int periodD, int periodK, int smooth)
        {
            if (cacheGaplessStochastics != null)
                for (int idx = 0; idx < cacheGaplessStochastics.Length; idx++)
                    if (cacheGaplessStochastics[idx].PeriodD == periodD && cacheGaplessStochastics[idx].PeriodK == periodK && cacheGaplessStochastics[idx].Smooth == smooth && cacheGaplessStochastics[idx].EqualsInput(input))
                        return cacheGaplessStochastics[idx];

            lock (checkGaplessStochastics)
            {
                checkGaplessStochastics.PeriodD = periodD;
                periodD = checkGaplessStochastics.PeriodD;
                checkGaplessStochastics.PeriodK = periodK;
                periodK = checkGaplessStochastics.PeriodK;
                checkGaplessStochastics.Smooth = smooth;
                smooth = checkGaplessStochastics.Smooth;

                if (cacheGaplessStochastics != null)
                    for (int idx = 0; idx < cacheGaplessStochastics.Length; idx++)
                        if (cacheGaplessStochastics[idx].PeriodD == periodD && cacheGaplessStochastics[idx].PeriodK == periodK && cacheGaplessStochastics[idx].Smooth == smooth && cacheGaplessStochastics[idx].EqualsInput(input))
                            return cacheGaplessStochastics[idx];

                GaplessStochastics indicator = new GaplessStochastics();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.PeriodD = periodD;
                indicator.PeriodK = periodK;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessStochastics[] tmp = new GaplessStochastics[cacheGaplessStochastics == null ? 1 : cacheGaplessStochastics.Length + 1];
                if (cacheGaplessStochastics != null)
                    cacheGaplessStochastics.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessStochastics = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessSupportResistance
        /// </summary>
        /// <returns></returns>
        public GaplessSupportResistance GaplessSupportResistance(int period)
        {
            return GaplessSupportResistance(Input, period);
        }

        /// <summary>
        /// GaplessSupportResistance
        /// </summary>
        /// <returns></returns>
        public GaplessSupportResistance GaplessSupportResistance(Data.IDataSeries input, int period)
        {
            if (cacheGaplessSupportResistance != null)
                for (int idx = 0; idx < cacheGaplessSupportResistance.Length; idx++)
                    if (cacheGaplessSupportResistance[idx].Period == period && cacheGaplessSupportResistance[idx].EqualsInput(input))
                        return cacheGaplessSupportResistance[idx];

            lock (checkGaplessSupportResistance)
            {
                checkGaplessSupportResistance.Period = period;
                period = checkGaplessSupportResistance.Period;

                if (cacheGaplessSupportResistance != null)
                    for (int idx = 0; idx < cacheGaplessSupportResistance.Length; idx++)
                        if (cacheGaplessSupportResistance[idx].Period == period && cacheGaplessSupportResistance[idx].EqualsInput(input))
                            return cacheGaplessSupportResistance[idx];

                GaplessSupportResistance indicator = new GaplessSupportResistance();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessSupportResistance[] tmp = new GaplessSupportResistance[cacheGaplessSupportResistance == null ? 1 : cacheGaplessSupportResistance.Length + 1];
                if (cacheGaplessSupportResistance != null)
                    cacheGaplessSupportResistance.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessSupportResistance = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GaplessWMA
        /// </summary>
        /// <returns></returns>
        public GaplessWMA GaplessWMA(int period)
        {
            return GaplessWMA(Input, period);
        }

        /// <summary>
        /// GaplessWMA
        /// </summary>
        /// <returns></returns>
        public GaplessWMA GaplessWMA(Data.IDataSeries input, int period)
        {
            if (cacheGaplessWMA != null)
                for (int idx = 0; idx < cacheGaplessWMA.Length; idx++)
                    if (cacheGaplessWMA[idx].Period == period && cacheGaplessWMA[idx].EqualsInput(input))
                        return cacheGaplessWMA[idx];

            lock (checkGaplessWMA)
            {
                checkGaplessWMA.Period = period;
                period = checkGaplessWMA.Period;

                if (cacheGaplessWMA != null)
                    for (int idx = 0; idx < cacheGaplessWMA.Length; idx++)
                        if (cacheGaplessWMA[idx].Period == period && cacheGaplessWMA[idx].EqualsInput(input))
                            return cacheGaplessWMA[idx];

                GaplessWMA indicator = new GaplessWMA();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                GaplessWMA[] tmp = new GaplessWMA[cacheGaplessWMA == null ? 1 : cacheGaplessWMA.Length + 1];
                if (cacheGaplessWMA != null)
                    cacheGaplessWMA.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGaplessWMA = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// GaplessADX
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessADX GaplessADX(int period)
        {
            return _indicator.GaplessADX(Input, period);
        }

        /// <summary>
        /// GaplessADX
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessADX GaplessADX(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessADX(input, period);
        }

        /// <summary>
        /// GaplessATR
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessATR GaplessATR(int period)
        {
            return _indicator.GaplessATR(Input, period);
        }

        /// <summary>
        /// GaplessATR
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessATR GaplessATR(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessATR(input, period);
        }

        /// <summary>
        /// GaplessBands
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessBands GaplessBands(double numStdDev, int period)
        {
            return _indicator.GaplessBands(Input, numStdDev, period);
        }

        /// <summary>
        /// GaplessBands
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessBands GaplessBands(Data.IDataSeries input, double numStdDev, int period)
        {
            return _indicator.GaplessBands(input, numStdDev, period);
        }

        /// <summary>
        /// GaplessCCI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessCCI GaplessCCI(int period)
        {
            return _indicator.GaplessCCI(Input, period);
        }

        /// <summary>
        /// GaplessCCI
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessCCI GaplessCCI(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessCCI(input, period);
        }

        /// <summary>
        /// GaplessDI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessDI GaplessDI(int period)
        {
            return _indicator.GaplessDI(Input, period);
        }

        /// <summary>
        /// GaplessDI
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessDI GaplessDI(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessDI(input, period);
        }

        /// <summary>
        /// GaplessEMA
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessEMA GaplessEMA(int period)
        {
            return _indicator.GaplessEMA(Input, period);
        }

        /// <summary>
        /// GaplessEMA
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessEMA GaplessEMA(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessEMA(input, period);
        }

        /// <summary>
        /// GaplessHMA
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessHMA GaplessHMA(int period)
        {
            return _indicator.GaplessHMA(Input, period);
        }

        /// <summary>
        /// GaplessHMA
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessHMA GaplessHMA(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessHMA(input, period);
        }

        /// <summary>
        /// GaplessLinearRegression
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessLinearRegression GaplessLinearRegression(int period)
        {
            return _indicator.GaplessLinearRegression(Input, period);
        }

        /// <summary>
        /// GaplessLinearRegression
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessLinearRegression GaplessLinearRegression(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessLinearRegression(input, period);
        }

        /// <summary>
        /// GaplessMACD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessMACD GaplessMACD(int fast, int slow, int smooth)
        {
            return _indicator.GaplessMACD(Input, fast, slow, smooth);
        }

        /// <summary>
        /// GaplessMACD
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessMACD GaplessMACD(Data.IDataSeries input, int fast, int slow, int smooth)
        {
            return _indicator.GaplessMACD(input, fast, slow, smooth);
        }

        /// <summary>
        /// GaplessParabolicSAR
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessParabolicSAR GaplessParabolicSAR(double acceleration, double accelerationMax, double accelerationStep)
        {
            return _indicator.GaplessParabolicSAR(Input, acceleration, accelerationMax, accelerationStep);
        }

        /// <summary>
        /// GaplessParabolicSAR
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessParabolicSAR GaplessParabolicSAR(Data.IDataSeries input, double acceleration, double accelerationMax, double accelerationStep)
        {
            return _indicator.GaplessParabolicSAR(input, acceleration, accelerationMax, accelerationStep);
        }

        /// <summary>
        /// GaplessRSI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessRSI GaplessRSI(int period, int smooth)
        {
            return _indicator.GaplessRSI(Input, period, smooth);
        }

        /// <summary>
        /// GaplessRSI
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessRSI GaplessRSI(Data.IDataSeries input, int period, int smooth)
        {
            return _indicator.GaplessRSI(input, period, smooth);
        }

        /// <summary>
        /// GaplessSMA
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessSMA GaplessSMA(int period)
        {
            return _indicator.GaplessSMA(Input, period);
        }

        /// <summary>
        /// GaplessSMA
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessSMA GaplessSMA(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessSMA(input, period);
        }

        /// <summary>
        /// GaplessStochastics
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessStochastics GaplessStochastics(int periodD, int periodK, int smooth)
        {
            return _indicator.GaplessStochastics(Input, periodD, periodK, smooth);
        }

        /// <summary>
        /// GaplessStochastics
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessStochastics GaplessStochastics(Data.IDataSeries input, int periodD, int periodK, int smooth)
        {
            return _indicator.GaplessStochastics(input, periodD, periodK, smooth);
        }

        /// <summary>
        /// GaplessSupportResistance
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessSupportResistance GaplessSupportResistance(int period)
        {
            return _indicator.GaplessSupportResistance(Input, period);
        }

        /// <summary>
        /// GaplessSupportResistance
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessSupportResistance GaplessSupportResistance(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessSupportResistance(input, period);
        }

        /// <summary>
        /// GaplessWMA
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessWMA GaplessWMA(int period)
        {
            return _indicator.GaplessWMA(Input, period);
        }

        /// <summary>
        /// GaplessWMA
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessWMA GaplessWMA(Data.IDataSeries input, int period)
        {
            return _indicator.GaplessWMA(input, period);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// GaplessADX
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessADX GaplessADX(int period)
        {
            return _indicator.GaplessADX(Input, period);
        }

        /// <summary>
        /// GaplessADX
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessADX GaplessADX(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessADX(input, period);
        }

        /// <summary>
        /// GaplessATR
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessATR GaplessATR(int period)
        {
            return _indicator.GaplessATR(Input, period);
        }

        /// <summary>
        /// GaplessATR
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessATR GaplessATR(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessATR(input, period);
        }

        /// <summary>
        /// GaplessBands
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessBands GaplessBands(double numStdDev, int period)
        {
            return _indicator.GaplessBands(Input, numStdDev, period);
        }

        /// <summary>
        /// GaplessBands
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessBands GaplessBands(Data.IDataSeries input, double numStdDev, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessBands(input, numStdDev, period);
        }

        /// <summary>
        /// GaplessCCI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessCCI GaplessCCI(int period)
        {
            return _indicator.GaplessCCI(Input, period);
        }

        /// <summary>
        /// GaplessCCI
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessCCI GaplessCCI(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessCCI(input, period);
        }

        /// <summary>
        /// GaplessDI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessDI GaplessDI(int period)
        {
            return _indicator.GaplessDI(Input, period);
        }

        /// <summary>
        /// GaplessDI
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessDI GaplessDI(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessDI(input, period);
        }

        /// <summary>
        /// GaplessEMA
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessEMA GaplessEMA(int period)
        {
            return _indicator.GaplessEMA(Input, period);
        }

        /// <summary>
        /// GaplessEMA
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessEMA GaplessEMA(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessEMA(input, period);
        }

        /// <summary>
        /// GaplessHMA
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessHMA GaplessHMA(int period)
        {
            return _indicator.GaplessHMA(Input, period);
        }

        /// <summary>
        /// GaplessHMA
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessHMA GaplessHMA(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessHMA(input, period);
        }

        /// <summary>
        /// GaplessLinearRegression
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessLinearRegression GaplessLinearRegression(int period)
        {
            return _indicator.GaplessLinearRegression(Input, period);
        }

        /// <summary>
        /// GaplessLinearRegression
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessLinearRegression GaplessLinearRegression(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessLinearRegression(input, period);
        }

        /// <summary>
        /// GaplessMACD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessMACD GaplessMACD(int fast, int slow, int smooth)
        {
            return _indicator.GaplessMACD(Input, fast, slow, smooth);
        }

        /// <summary>
        /// GaplessMACD
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessMACD GaplessMACD(Data.IDataSeries input, int fast, int slow, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessMACD(input, fast, slow, smooth);
        }

        /// <summary>
        /// GaplessParabolicSAR
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessParabolicSAR GaplessParabolicSAR(double acceleration, double accelerationMax, double accelerationStep)
        {
            return _indicator.GaplessParabolicSAR(Input, acceleration, accelerationMax, accelerationStep);
        }

        /// <summary>
        /// GaplessParabolicSAR
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessParabolicSAR GaplessParabolicSAR(Data.IDataSeries input, double acceleration, double accelerationMax, double accelerationStep)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessParabolicSAR(input, acceleration, accelerationMax, accelerationStep);
        }

        /// <summary>
        /// GaplessRSI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessRSI GaplessRSI(int period, int smooth)
        {
            return _indicator.GaplessRSI(Input, period, smooth);
        }

        /// <summary>
        /// GaplessRSI
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessRSI GaplessRSI(Data.IDataSeries input, int period, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessRSI(input, period, smooth);
        }

        /// <summary>
        /// GaplessSMA
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessSMA GaplessSMA(int period)
        {
            return _indicator.GaplessSMA(Input, period);
        }

        /// <summary>
        /// GaplessSMA
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessSMA GaplessSMA(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessSMA(input, period);
        }

        /// <summary>
        /// GaplessStochastics
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessStochastics GaplessStochastics(int periodD, int periodK, int smooth)
        {
            return _indicator.GaplessStochastics(Input, periodD, periodK, smooth);
        }

        /// <summary>
        /// GaplessStochastics
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessStochastics GaplessStochastics(Data.IDataSeries input, int periodD, int periodK, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessStochastics(input, periodD, periodK, smooth);
        }

        /// <summary>
        /// GaplessSupportResistance
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessSupportResistance GaplessSupportResistance(int period)
        {
            return _indicator.GaplessSupportResistance(Input, period);
        }

        /// <summary>
        /// GaplessSupportResistance
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessSupportResistance GaplessSupportResistance(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessSupportResistance(input, period);
        }

        /// <summary>
        /// GaplessWMA
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GaplessWMA GaplessWMA(int period)
        {
            return _indicator.GaplessWMA(Input, period);
        }

        /// <summary>
        /// GaplessWMA
        /// </summary>
        /// <returns></returns>
        public Indicator.GaplessWMA GaplessWMA(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GaplessWMA(input, period);
        }
    }
}
#endregion
